/* Generated automatically by the program `genrecog'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"

extern rtx gen_split_3 ();
extern rtx gen_split_5 ();
extern rtx gen_split_6 ();
extern rtx gen_split_8 ();
extern rtx gen_split_11 ();
extern rtx gen_split_14 ();
extern rtx gen_split_16 ();
extern rtx gen_split_18 ();
extern rtx gen_split_20 ();
extern rtx gen_split_47 ();
extern rtx gen_split_73 ();
extern rtx gen_split_118 ();
extern rtx gen_split_119 ();
extern rtx gen_split_123 ();
extern rtx gen_split_124 ();
extern rtx gen_split_125 ();
extern rtx gen_split_126 ();
extern rtx gen_split_128 ();
extern rtx gen_split_131 ();
extern rtx gen_split_134 ();
extern rtx gen_split_136 ();
extern rtx gen_split_140 ();
extern rtx gen_split_183 ();
extern rtx gen_split_184 ();
extern rtx gen_split_185 ();
extern rtx gen_split_186 ();
extern rtx gen_split_187 ();
extern rtx gen_split_219 ();
extern rtx gen_split_222 ();

/* `recog' contains a decision tree
   that recognizes whether the rtx X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.
   If the rtx is valid, recog returns a nonnegative number
   which is the insn code number for the pattern that matched.
   This is the same as the order in the machine description of
   the entry that matched.  This number can be used as an index into
   entry that matched.  This number can be used as an index into various
   insn_* tables, such as insn_templates, insn_outfun, and insn_n_operands
   (found in insn-output.c).

   The third argument to recog is an optional pointer to an int.
   If present, recog will accept a pattern if it matches except for
   missing CLOBBER expressions at the end.  In that case, the value
   pointed to by the optional pointer will be set to the number of
   CLOBBERs that need to be added (it should be initialized to zero by
   the caller).  If it is set nonzero, the caller should allocate a
   PARALLEL of the appropriate size, copy the initial entries, and call
   add_clobbers (found in insn-emit.c) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl in a SEQUENCE if it can be.*/

rtx recog_operand[MAX_RECOG_OPERANDS];

rtx *recog_operand_loc[MAX_RECOG_OPERANDS];

rtx *recog_dup_loc[MAX_DUP_OPERANDS];

char recog_dup_num[MAX_DUP_OPERANDS];

#define operands recog_operand

int
recog_1 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DImode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      goto L17;
    case PLUS:
      goto L81;
    case NEG:
      goto L167;
    case MINUS:
      goto L202;
    case MULT:
      goto L220;
    case TRUNCATE:
      goto L225;
    case AND:
      goto L308;
    case ZERO_EXTEND:
      goto L292;
    case IOR:
      goto L323;
    case NOT:
      goto L334;
    case XOR:
      goto L329;
    case ASHIFT:
      goto L369;
    case LSHIFTRT:
      goto L345;
    case ASHIFTRT:
      goto L350;
    case ZERO_EXTRACT:
      goto L355;
    case FIX:
      goto L513;
    case NE:
      goto L620;
    case GT:
      goto L625;
    case GE:
      goto L630;
    case IF_THEN_ELSE:
      goto L643;
    case SMAX:
      goto L755;
    case SMIN:
      goto L768;
    case EQ:
    case LE:
    case LT:
    case LEU:
    case LTU:
      if (alpha_comparison_operator (x1, DImode))
	{
	  ro[1] = x1;
	  goto L615;
	}
    }
  goto ret0;

  L17:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case PLUS:
      goto L61;
    case NEG:
      goto L163;
    case MINUS:
      goto L195;
    case MULT:
      goto L215;
    case SUBREG:
    case REG:
    case MEM:
      if (nonimmediate_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 0;
	}
    }
  goto ret0;

  L61:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L62;
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L19;
    }
  goto ret0;

  L62:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L63;
    }
  goto ret0;

  L63:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L64;
    }
  goto ret0;

  L64:
  x3 = XEXP (x2, 1);
  if (sext_add_operand (x3, SImode))
    {
      ro[3] = x3;
      return 10;
    }
  goto ret0;

  L19:
  x3 = XEXP (x2, 1);
  if (sext_add_operand (x3, SImode))
    {
      ro[2] = x3;
      return 4;
    }
  goto ret0;

  L163:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[1] = x3;
      return 22;
    }
  goto ret0;

  L195:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L196;
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L178;
    }
  goto ret0;

  L196:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L197;
    }
  goto ret0;

  L197:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L198;
    }
  goto ret0;

  L198:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[3] = x3;
      return 29;
    }
  goto ret0;

  L178:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[2] = x3;
      return 26;
    }
  goto ret0;

  L215:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L216;
    }
  goto ret0;

  L216:
  x3 = XEXP (x2, 1);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[2] = x3;
      return 32;
    }
  goto ret0;

  L81:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MULT && 1)
    goto L82;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L44;
    }
  goto ret0;

  L82:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L83;
    }
  goto ret0;

  L83:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L84;
    }
  goto ret0;

  L84:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 12;
    }
  goto ret0;

  L44:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, DImode))
    {
      ro[2] = x2;
      return 7;
    }
  goto ret0;

  L167:
  x2 = XEXP (x1, 0);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      return 23;
    }
  goto ret0;

  L202:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MULT && 1)
    goto L203;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L183;
    }
  goto ret0;

  L203:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L204;
    }
  goto ret0;

  L204:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L205;
    }
  goto ret0;

  L205:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 30;
    }
  goto ret0;

  L183:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 27;
    }
  goto ret0;

  L220:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L221;
    }
  goto ret0;

  L221:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      return 33;
    }
  goto ret0;

  L225:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == TImode && GET_CODE (x2) == LSHIFTRT && 1)
    goto L226;
  goto ret0;

  L226:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == TImode && GET_CODE (x3) == MULT && 1)
    goto L227;
  goto ret0;

  L227:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == TImode && GET_CODE (x4) == ZERO_EXTEND && 1)
    goto L228;
  goto ret0;

  L228:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[1] = x5;
      goto L229;
    }
  goto ret0;

  L229:
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) == TImode && 1)
	goto L230;
      break;
    case CONST_INT:
      if (GET_CODE (x4) == CONST_INT && cint8_operand (x4, TImode))
	{
	  ro[2] = x4;
	  goto L240;
	}
    }
  goto ret0;

  L230:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L231;
    }
  goto ret0;

  L231:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 64 && 1)
    return 34;
  goto ret0;

  L240:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 64 && 1)
    return 35;
  goto ret0;

  L308:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == NOT && 1)
    goto L461;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L275;
    }
  goto ret0;

  L461:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L462;
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L310;
    }
  goto ret0;

  L462:
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == CONST_INT && mode_mask_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L463;
    }
  goto ret0;

  L463:
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ASHIFT && 1)
    goto L464;
  goto ret0;

  L464:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[3] = x5;
      goto L465;
    }
  goto ret0;

  L465:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 3 && 1)
    goto L466;
  goto ret0;

  L466:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      return 80;
    }
  goto ret0;

  L310:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      return 54;
    }
  goto ret0;

  L275:
  x2 = XEXP (x1, 1);
  if (and_operand (x2, DImode))
    {
      ro[2] = x2;
      return 46;
    }
  goto ret0;

  L292:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 50;
	}
      break;
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 52;
	}
      break;
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 53;
	}
    }
  goto ret0;

  L323:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == NOT && 1)
    goto L324;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L315;
    }
  goto ret0;

  L324:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L325;
    }
  goto ret0;

  L325:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      return 57;
    }
  goto ret0;

  L315:
  x2 = XEXP (x1, 1);
  if (or_operand (x2, DImode))
    {
      ro[2] = x2;
      return 55;
    }
  goto ret0;

  L334:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == XOR && 1)
    goto L335;
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      return 56;
    }
  goto ret0;

  L335:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L336;
    }
  goto ret0;

  L336:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, DImode))
    {
      ro[2] = x3;
      return 59;
    }
  goto ret0;

  L329:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L330;
    }
  goto ret0;

  L330:
  x2 = XEXP (x1, 1);
  if (or_operand (x2, DImode))
    {
      ro[2] = x2;
      return 58;
    }
  goto ret0;

  L369:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DImode:
      switch (GET_CODE (x2))
	{
	case ZERO_EXTRACT:
	  goto L370;
	case ZERO_EXTEND:
	  goto L419;
	}
    }
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L341;
    }
  goto ret0;

  L370:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L371;
    }
  goto ret0;

  L371:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    goto ret0;
  if (XWINT (x3, 0) == 8 && 1)
    goto L372;
  if (GET_CODE (x3) != CONST_INT)
    goto ret0;
  if (XWINT (x3, 0) == 16 && 1)
    goto L384;
  if (XWINT (x3, 0) == 32 && 1)
    goto L396;
  goto ret0;

  L372:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L373;
  goto ret0;

  L373:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L374;
  goto ret0;

  L374:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L375;
    }
  goto ret0;

  L375:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -1 && 1)
    goto L376;
  goto ret0;

  L376:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L377;
  goto ret0;

  L377:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 56 && 1)
    return 70;
  goto ret0;

  L384:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L385;
  goto ret0;

  L385:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L386;
  goto ret0;

  L386:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L387;
    }
  goto ret0;

  L387:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -2 && 1)
    goto L388;
  goto ret0;

  L388:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L389;
  goto ret0;

  L389:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 48 && 1)
    return 71;
  goto ret0;

  L396:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L397;
  goto ret0;

  L397:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L398;
  goto ret0;

  L398:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L399;
    }
  goto ret0;

  L399:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -4 && 1)
    goto L400;
  goto ret0;

  L400:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L401;
  goto ret0;

  L401:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 32 && 1)
    return 72;
  goto ret0;

  L419:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case QImode:
      if (register_operand (x3, QImode))
	{
	  ro[1] = x3;
	  goto L438;
	}
      break;
    case HImode:
      if (register_operand (x3, HImode))
	{
	  ro[1] = x3;
	  goto L446;
	}
      break;
    case SImode:
      if (register_operand (x3, SImode))
	{
	  ro[1] = x3;
	  goto L454;
	}
    }
  goto ret0;

  L438:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L439;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 74;
	}
    }
  goto ret0;

  L439:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L440;
    }
  goto ret0;

  L440:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 77;
  goto ret0;

  L446:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L447;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 75;
	}
    }
  goto ret0;

  L447:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L448;
    }
  goto ret0;

  L448:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 78;
  goto ret0;

  L454:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L455;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 76;
	}
    }
  goto ret0;

  L455:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L456;
    }
  goto ret0;

  L456:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 79;
  goto ret0;

  L341:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 60;
    }
  goto ret0;

  L345:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L346;
    }
  goto ret0;

  L346:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 61;
    }
  goto ret0;

  L350:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L351;
    }
  goto ret0;

  L351:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 62;
    }
  goto ret0;

  L355:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L356;
    }
  goto ret0;

  L356:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && mode_width_operand (x2, DImode))
    {
      ro[2] = x2;
      goto L363;
    }
  goto ret0;

  L363:
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L364;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[3] = x2;
	  return 68;
	}
    }
  goto ret0;

  L364:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L365;
    }
  goto ret0;

  L365:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 69;
  goto ret0;

  L513:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L514;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 89;
      }
  goto ret0;

  L514:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      if (TARGET_FP)
	return 90;
      }
  goto ret0;

  L620:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L621;
    }
  goto ret0;

  L621:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 110;
  goto ret0;

  L625:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L626;
    }
  goto ret0;

  L626:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 111;
  goto ret0;

  L630:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L631;
    }
  goto ret0;

  L631:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 112;
  goto ret0;

  L643:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[2] = x2;
      goto L644;
    }
  L651:
  switch (GET_CODE (x2))
    {
    case EQ:
      goto L652;
    case NE:
      goto L663;
    }
  goto ret0;

  L644:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L645;
    }
  goto L651;

  L645:
  x3 = XEXP (x2, 1);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L646;
    }
  L688:
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L689;
  goto L651;

  L646:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L647;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  goto L688;

  L647:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[5] = x2;
      if (operands[3] == const0_rtx || operands[4] == const0_rtx)
	return 114;
      }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  goto L688;

  L689:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == PLUS && 1)
    goto L690;
  x2 = XEXP (x1, 0);
  goto L651;

  L690:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L691;
  x2 = XEXP (x1, 0);
  goto L651;

  L691:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L692;
    }
  x2 = XEXP (x1, 0);
  goto L651;

  L692:
  x2 = XEXP (x1, 2);
  if (rtx_equal_p (x2, ro[0]) && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 1;
      return 117;
    }
  x2 = XEXP (x1, 0);
  goto L651;

  L652:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L653;
  goto ret0;

  L653:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L654;
    }
  goto ret0;

  L654:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L655;
  goto ret0;

  L655:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L656;
  goto ret0;

  L656:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L657;
  goto ret0;

  L657:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L658;
    }
  goto ret0;

  L658:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 115;
    }
  goto ret0;

  L663:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L664;
  goto ret0;

  L664:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L665;
    }
  goto ret0;

  L665:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L666;
  goto ret0;

  L666:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L667;
  goto ret0;

  L667:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L668;
  goto ret0;

  L668:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L669;
    }
  goto ret0;

  L669:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 116;
    }
  goto ret0;

  L755:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L756;
    }
  goto ret0;

  L756:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 129;
  goto ret0;

  L768:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L769;
    }
  goto ret0;

  L769:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 132;
  goto ret0;

  L615:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      goto L616;
    }
  goto ret0;

  L616:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 109;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_2 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DFmode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case ABS:
      goto L474;
    case NEG:
      goto L482;
    case PLUS:
      goto L496;
    case FLOAT:
      goto L522;
    case FLOAT_EXTEND:
      goto L526;
    case DIV:
      goto L544;
    case MULT:
      goto L573;
    case MINUS:
      goto L596;
    case IF_THEN_ELSE:
      goto L861;
    case EQ:
    case LE:
    case LT:
    case LEU:
    case LTU:
      if (alpha_comparison_operator (x1, DFmode))
	{
	  ro[1] = x1;
	  goto L842;
	}
    }
  goto ret0;

  L474:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 82;
      }
  goto ret0;

  L482:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 84;
      }
  goto ret0;

  L496:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L497;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L492;
    }
  goto ret0;

  L497:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L504;
    }
  goto ret0;

  L504:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L505;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 87;
      }
  goto ret0;

  L505:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 88;
      }
  goto ret0;

  L492:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 86;
      }
  goto ret0;

  L522:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 92;
      }
  goto ret0;

  L526:
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 93;
      }
  goto ret0;

  L544:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L545;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L551;
    }
  goto ret0;

  L545:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L558;
    }
  goto ret0;

  L558:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L559;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 97;
      }
  goto ret0;

  L559:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 99;
      }
  goto ret0;

  L551:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L552;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 96;
      }
  goto ret0;

  L552:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 98;
      }
  goto ret0;

  L573:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L574;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L569;
    }
  goto ret0;

  L574:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L581;
    }
  goto ret0;

  L581:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L582;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 102;
      }
  goto ret0;

  L582:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 103;
      }
  goto ret0;

  L569:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 101;
      }
  goto ret0;

  L596:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L597;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L603;
    }
  goto ret0;

  L597:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L610;
    }
  goto ret0;

  L610:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L611;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 106;
      }
  goto ret0;

  L611:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 108;
      }
  goto ret0;

  L603:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L604;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 105;
      }
  goto ret0;

  L604:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 107;
      }
  goto ret0;

  L861:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[3] = x2;
      goto L887;
    }
  goto ret0;

  L887:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != DFmode)
    goto ret0;
  if (GET_CODE (x3) == FLOAT_EXTEND && 1)
    goto L888;
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[4] = x3;
      goto L863;
    }
  L878:
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[1] = x3;
      goto L879;
    }
  goto ret0;

  L888:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[4] = x4;
      goto L889;
    }
  goto ret0;

  L889:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L908;
    }
  goto ret0;

  L908:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L909;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L891;
    }
  goto ret0;

  L909:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L910;
    }
  goto ret0;

  L910:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 150;
      }
  goto ret0;

  L891:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 148;
      }
  goto ret0;

  L863:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L864;
    }
  x3 = XEXP (x2, 0);
  goto L878;

  L864:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L865;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L878;

  L865:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 145;
      }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L878;

  L879:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L880;
    }
  goto ret0;

  L880:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode && GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L881;
  goto ret0;

  L881:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[4] = x3;
      goto L882;
    }
  goto ret0;

  L882:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 147;
      }
  goto ret0;

  L842:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L843;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      goto L849;
    }
  goto ret0;

  L843:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      goto L856;
    }
  goto ret0;

  L856:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L857;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[3] = x2;
      if (TARGET_FP)
	return 142;
      }
  goto ret0;

  L857:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[3] = x3;
      if (TARGET_FP)
	return 144;
      }
  goto ret0;

  L849:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L850;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[3] = x2;
      if (TARGET_FP)
	return 141;
      }
  goto ret0;

  L850:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[3] = x3;
      if (TARGET_FP)
	return 143;
      }
  goto ret0;
 ret0: return -1;
}

int
recog_3 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case DImode:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L2;
	}
    L86:
      if (some_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L87;
	}
    L1099:
      if (general_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L1100;
	}
      break;
    case SImode:
      if (GET_CODE (x1) == REG && XINT (x1, 0) == 27 && 1)
	goto L253;
    L5:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L6;
	}
    L100:
      if (some_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L101;
	}
    L1082:
      if (nonimmediate_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L1083;
	}
    }
  L267:
  switch (GET_MODE (x1))
    {
    case DImode:
      if (GET_CODE (x1) == REG && XINT (x1, 0) == 27 && 1)
	goto L268;
      break;
    case HImode:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L283;
	}
    L1090:
      if (nonimmediate_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L1091;
	}
      break;
    case SFmode:
      if (register_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L469;
	}
    L1076:
      if (nonimmediate_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L1077;
	}
      break;
    case DFmode:
      if (register_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L473;
	}
    L1079:
      if (nonimmediate_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L1080;
	}
      break;
    case QImode:
      if (nonimmediate_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L1094;
	}
    }
  if (GET_CODE (x1) == PC && 1)
    goto L1062;
  L1020:
  if (register_operand (x1, VOIDmode))
    {
      ro[0] = x1;
      goto L1021;
    }
  goto ret0;
 L2:
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L86;

  L87:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DImode)
    {
      x1 = XEXP (x0, 0);
      goto L1099;
    }
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L88;
    case SIGN_EXTEND:
      goto L120;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L88:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == PLUS && 1)
    goto L141;
  x1 = XEXP (x0, 0);
  goto L1099;

  L141:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MULT && 1)
    goto L142;
  if (some_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L90;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L142:
  x4 = XEXP (x3, 0);
  if (some_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L143;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L143:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L144;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L144:
  x3 = XEXP (x2, 1);
  if (some_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L145;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L145:
  x2 = XEXP (x1, 1);
  if (some_operand (x2, DImode))
    {
      ro[4] = x2;
      if (reload_in_progress)
	return 19;
      }
  x1 = XEXP (x0, 0);
  goto L1099;

  L90:
  x3 = XEXP (x2, 1);
  if (some_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L91;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L91:
  x2 = XEXP (x1, 1);
  if (some_operand (x2, DImode))
    {
      ro[3] = x2;
      if (reload_in_progress)
	return 13;
      }
  x1 = XEXP (x0, 0);
  goto L1099;

  L120:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L121;
  x1 = XEXP (x0, 0);
  goto L1099;

  L121:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L122;
  x1 = XEXP (x0, 0);
  goto L1099;

  L122:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L123;
  x1 = XEXP (x0, 0);
  goto L1099;

  L123:
  x5 = XEXP (x4, 0);
  if (some_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L124;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L124:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && const48_operand (x5, SImode))
    {
      ro[2] = x5;
      goto L125;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L125:
  x4 = XEXP (x3, 1);
  if (some_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L126;
    }
  x1 = XEXP (x0, 0);
  goto L1099;

  L126:
  x3 = XEXP (x2, 1);
  if (some_operand (x3, SImode))
    {
      ro[4] = x3;
      if (reload_in_progress)
	return 17;
      }
  x1 = XEXP (x0, 0);
  goto L1099;

  L1100:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, DImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode))
	return 220;
      }
  x1 = XEXP (x0, 0);
  goto L267;

  L253:
  x1 = XEXP (x0, 1);
  if (divmod_operator (x1, SImode))
    {
      ro[1] = x1;
      goto L254;
    }
  x1 = XEXP (x0, 0);
  goto L5;

  L254:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 24 && 1)
    goto L255;
  x1 = XEXP (x0, 0);
  goto L5;

  L255:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 2;
      return 44;
    }
  x1 = XEXP (x0, 0);
  goto L5;

  L6:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case SImode:
      switch (GET_CODE (x1))
	{
	case PLUS:
	  goto L53;
	case NEG:
	  goto L158;
	case MINUS:
	  goto L187;
	case MULT:
	  goto L209;
	case ZERO_EXTEND:
	  goto L288;
	}
      break;
    case DImode:
      if (GET_CODE (x1) == IF_THEN_ELSE && 1)
	goto L635;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L53:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MULT && 1)
    goto L54;
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L8;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L54:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L55;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L55:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L56;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L56:
  x2 = XEXP (x1, 1);
  if (sext_add_operand (x2, SImode))
    {
      ro[3] = x2;
      return 9;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L8:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, SImode))
    {
      ro[2] = x2;
      return 2;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L158:
  x2 = XEXP (x1, 0);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[1] = x2;
      return 21;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L187:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MULT && 1)
    goto L188;
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L172;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L188:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L189;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L189:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L190;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L190:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[3] = x2;
      return 28;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L172:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[2] = x2;
      return 25;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L209:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L210;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L210:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SImode))
    {
      ro[2] = x2;
      return 31;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L288:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 49;
	}
      break;
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 51;
	}
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L635:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[2] = x2;
      goto L636;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L636:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L637;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L637:
  x3 = XEXP (x2, 1);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L638;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L638:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L639;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L639:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[5] = x2;
      if (operands[3] == const0_rtx || operands[4] == const0_rtx)
	return 113;
      }
  x1 = XEXP (x0, 0);
  goto L100;

  L101:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode && GET_CODE (x1) == PLUS && 1)
    goto L102;
  x1 = XEXP (x0, 0);
  goto L1082;

  L102:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L103;
  x1 = XEXP (x0, 0);
  goto L1082;

  L103:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L104;
  x1 = XEXP (x0, 0);
  goto L1082;

  L104:
  x4 = XEXP (x3, 0);
  if (some_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L105;
    }
  x1 = XEXP (x0, 0);
  goto L1082;

  L105:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L106;
    }
  x1 = XEXP (x0, 0);
  goto L1082;

  L106:
  x3 = XEXP (x2, 1);
  if (some_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L107;
    }
  x1 = XEXP (x0, 0);
  goto L1082;

  L107:
  x2 = XEXP (x1, 1);
  if (some_operand (x2, SImode))
    {
      ro[4] = x2;
      if (reload_in_progress)
	return 15;
      }
  x1 = XEXP (x0, 0);
  goto L1082;

  L1083:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, SImode))
    goto L1087;
  x1 = XEXP (x0, 0);
  goto L1020;

  L1087:
  ro[1] = x1;
  if (! WINDOWS_NT && (register_operand (operands[0], SImode)
		    || reg_or_0_operand (operands[1], SImode)))
    return 214;
  L1088:
  ro[1] = x1;
  if (WINDOWS_NT && (register_operand (operands[0], SImode)
		  || reg_or_0_operand (operands[1], SImode)))
    return 215;
  x1 = XEXP (x0, 0);
  goto L1020;

  L268:
  x1 = XEXP (x0, 1);
  if (divmod_operator (x1, DImode))
    {
      ro[1] = x1;
      goto L269;
    }
  x1 = XEXP (x0, 0);
  goto L1020;

  L269:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 24 && 1)
    goto L270;
  x1 = XEXP (x0, 0);
  goto L1020;

  L270:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 2;
      return 45;
    }
  x1 = XEXP (x0, 0);
  goto L1020;

  L283:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode && GET_CODE (x1) == ZERO_EXTEND && 1)
    goto L284;
  x1 = XEXP (x0, 0);
  goto L1090;

  L284:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      return 48;
    }
  x1 = XEXP (x0, 0);
  goto L1090;

  L1091:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, HImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], HImode)
   || register_operand (operands[1], HImode))
	return 216;
      }
  x1 = XEXP (x0, 0);
  goto L1020;

  L469:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SFmode)
    {
      x1 = XEXP (x0, 0);
      goto L1076;
    }
  switch (GET_CODE (x1))
    {
    case ABS:
      goto L470;
    case NEG:
      goto L478;
    case PLUS:
      goto L486;
    case FLOAT:
      goto L518;
    case FLOAT_TRUNCATE:
      goto L530;
    case DIV:
      goto L534;
    case MULT:
      goto L563;
    case MINUS:
      goto L586;
    case IF_THEN_ELSE:
      goto L869;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L470:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 81;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L478:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 83;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L486:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L487;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L487:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 85;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L518:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 91;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L530:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 94;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L534:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L535;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L535:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 95;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L563:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L564;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L564:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 100;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L586:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L587;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L587:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 104;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L869:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[3] = x2;
      goto L896;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L896:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != DFmode)
    {
      x1 = XEXP (x0, 0);
      goto L1076;
    }
  if (GET_CODE (x3) == FLOAT_EXTEND && 1)
    goto L897;
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[4] = x3;
      goto L871;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L897:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[4] = x4;
      goto L898;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L898:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L899;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L899:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L900;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L900:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 149;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L871:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L872;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L872:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L873;
    }
  x1 = XEXP (x0, 0);
  goto L1076;

  L873:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 146;
      }
  x1 = XEXP (x0, 0);
  goto L1076;

  L1077:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, SFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], SFmode)
   || reg_or_fp0_operand (operands[1], SFmode))
	return 210;
      }
  x1 = XEXP (x0, 0);
  goto L1020;
 L473:
  tem = recog_2 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L1079;

  L1080:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, DFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DFmode)
   || reg_or_fp0_operand (operands[1], DFmode))
	return 211;
      }
  x1 = XEXP (x0, 0);
  goto L1020;

  L1094:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, QImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode))
	return 217;
      }
  x1 = XEXP (x0, 0);
  goto L1020;

  L1062:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case DImode:
      if (GET_CODE (x1) == PLUS && 1)
	goto L1063;
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  return 202;
	}
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L789;
    case LABEL_REF:
      goto L1045;
    }
  goto ret0;

  L1063:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L1064;
    }
  goto ret0;

  L1064:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == LABEL_REF && 1)
    goto L1065;
  goto ret0;

  L1065:
  x3 = XEXP (x2, 0);
  if (pnum_clobbers != 0 && 1)
    {
      ro[1] = x3;
      if (! WINDOWS_NT && next_active_insn (insn) != 0
   && GET_CODE (PATTERN (next_active_insn (insn))) == ADDR_DIFF_VEC
   && PREV_INSN (next_active_insn (insn)) == operands[1])
	{
	  *pnum_clobbers = 1;
	  return 207;
	}
      }
  goto ret0;

  L789:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[1] = x2;
      goto L924;
    }
  L798:
  switch (GET_CODE (x2))
    {
    case NE:
      goto L799;
    case EQ:
      goto L811;
    }
  goto ret0;

  L924:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case DFmode:
      if (GET_CODE (x3) == FLOAT_EXTEND && 1)
	goto L925;
      if (reg_or_fp0_operand (x3, DFmode))
	{
	  ro[2] = x3;
	  goto L916;
	}
    }
  L790:
  if (reg_or_0_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L791;
    }
  goto L798;

  L925:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[2] = x4;
      goto L926;
    }
  goto L798;

  L926:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[3] = x3;
      goto L927;
    }
  goto L798;

  L927:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L928;
  x2 = XEXP (x1, 0);
  goto L798;

  L928:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L929;

  L929:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    if (TARGET_FP)
      return 156;
  x2 = XEXP (x1, 0);
  goto L798;

  L916:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[3] = x3;
      goto L917;
    }
  x3 = XEXP (x2, 0);
  goto L790;

  L917:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L918;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L790;

  L918:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L919;

  L919:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    if (TARGET_FP)
      return 155;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L790;

  L791:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L792;
  goto L798;

  L792:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L793;
  x2 = XEXP (x1, 0);
  goto L798;

  L793:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L794;

  L794:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 137;
  x2 = XEXP (x1, 0);
  goto L798;

  L799:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L800;
  goto ret0;

  L800:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L801;
    }
  goto ret0;

  L801:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L802;
  goto ret0;

  L802:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L803;
  goto ret0;

  L803:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L804;
  goto ret0;

  L804:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L805;
  goto ret0;

  L805:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L806;

  L806:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 138;
  goto ret0;

  L811:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L812;
  goto ret0;

  L812:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L813;
    }
  goto ret0;

  L813:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L814;
  goto ret0;

  L814:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L815;
  goto ret0;

  L815:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L816;
  goto ret0;

  L816:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L817;
  goto ret0;

  L817:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L818;

  L818:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 139;
  goto ret0;

  L1045:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  return 200;

  L1021:
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL && 1)
    goto L1022;
  goto ret0;

  L1022:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MEM && 1)
    goto L1023;
  goto ret0;

  L1023:
  x3 = XEXP (x2, 0);
  if (call_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L1024;
    }
  goto ret0;

  L1024:
  x2 = XEXP (x1, 1);
  if (pnum_clobbers != 0 && 1)
    {
      ro[2] = x2;
      if (! WINDOWS_NT)
	{
	  *pnum_clobbers = 2;
	  return 196;
	}
      }
  L1039:
  if (pnum_clobbers != 0 && 1)
    {
      ro[2] = x2;
      if (WINDOWS_NT)
	{
	  *pnum_clobbers = 1;
	  return 197;
	}
      }
  goto ret0;
 ret0: return -1;
}

int
recog (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  L0:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L1;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 3 && 1)
	goto L242;
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L671;
      break;
    case CALL:
      goto L994;
    case UNSPEC_VOLATILE:
      if (XINT (x0, 1) == 1 && XVECLEN (x0, 0) == 1 && 1)
	goto L1041;
      if (XINT (x0, 1) == 0 && XVECLEN (x0, 0) == 1 && 1)
	goto L1074;
      break;
    case RETURN:
      if (direct_return ())
	return 201;
      break;
    case CONST_INT:
      if (XWINT (x0, 0) == 0 && 1)
	return 203;
    }
  goto ret0;
 L1:
  return recog_3 (x0, insn, pnum_clobbers);

  L242:
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L243;
    case CALL:
      goto L986;
    }
  goto ret0;

  L243:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      switch (GET_CODE (x2))
	{
	case REG:
	  if (XINT (x2, 0) == 27 && 1)
	    goto L244;
	}
      break;
    case DImode:
      if (GET_CODE (x2) == REG && XINT (x2, 0) == 27 && 1)
	goto L259;
    }
  L1010:
  if (register_operand (x2, VOIDmode))
    {
      ro[0] = x2;
      goto L1011;
    }
  goto ret0;

  L244:
  x2 = XEXP (x1, 1);
  if (divmod_operator (x2, SImode))
    {
      ro[1] = x2;
      goto L245;
    }
  x2 = XEXP (x1, 0);
  goto L1010;

  L245:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 24 && 1)
    goto L246;
  x2 = XEXP (x1, 0);
  goto L1010;

  L246:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L247;
  x2 = XEXP (x1, 0);
  goto L1010;

  L247:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L248;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L248:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 23 && 1)
    goto L249;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L249:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L250;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L250:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 28 && 1)
    return 44;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L259:
  x2 = XEXP (x1, 1);
  if (divmod_operator (x2, DImode))
    {
      ro[1] = x2;
      goto L260;
    }
  x2 = XEXP (x1, 0);
  goto L1010;

  L260:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 24 && 1)
    goto L261;
  x2 = XEXP (x1, 0);
  goto L1010;

  L261:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L262;
  x2 = XEXP (x1, 0);
  goto L1010;

  L262:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L263;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L263:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 23 && 1)
    goto L264;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L264:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L265;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L265:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 28 && 1)
    return 45;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1010;

  L1011:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CALL && 1)
    goto L1012;
  goto ret0;

  L1012:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MEM && 1)
    goto L1013;
  goto ret0;

  L1013:
  x4 = XEXP (x3, 0);
  if (call_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L1014;
    }
  goto ret0;

  L1014:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L1015;

  L1015:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1016;
  goto ret0;

  L1016:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 27 && 1)
    goto L1017;
  goto ret0;

  L1017:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1018;
  goto ret0;

  L1018:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    if (! WINDOWS_NT)
      return 196;
  goto ret0;

  L986:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MEM && 1)
    goto L987;
  goto ret0;

  L987:
  x3 = XEXP (x2, 0);
  if (call_operand (x3, DImode))
    {
      ro[0] = x3;
      goto L988;
    }
  goto ret0;

  L988:
  x2 = XEXP (x1, 1);
  ro[1] = x2;
  goto L989;

  L989:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L990;
  goto ret0;

  L990:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 27 && 1)
    goto L991;
  goto ret0;

  L991:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L992;
  goto ret0;

  L992:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    if (! WINDOWS_NT)
      return 194;
  goto ret0;

  L671:
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L672;
    case CALL:
      goto L999;
    }
  goto ret0;

  L672:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L673;
    }
  if (GET_CODE (x2) == PC && 1)
    goto L1054;
  L1027:
  if (register_operand (x2, VOIDmode))
    {
      ro[0] = x2;
      goto L1028;
    }
  goto ret0;

  L673:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L674;
  x2 = XEXP (x1, 0);
  goto L1027;

  L674:
  x3 = XEXP (x2, 0);
  if (signed_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L675;
    }
  x2 = XEXP (x1, 0);
  goto L1027;

  L675:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L676;
    }
  x2 = XEXP (x1, 0);
  goto L1027;

  L676:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L677;
  x2 = XEXP (x1, 0);
  goto L1027;

  L677:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == PLUS && 1)
    goto L678;
  x2 = XEXP (x1, 0);
  goto L1027;

  L678:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L679;
  x2 = XEXP (x1, 0);
  goto L1027;

  L679:
  x4 = XEXP (x3, 1);
  if (reg_or_8bit_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L680;
    }
  x2 = XEXP (x1, 0);
  goto L1027;

  L680:
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L681;
  x2 = XEXP (x1, 0);
  goto L1027;

  L681:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L682;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1027;

  L682:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DImode))
    {
      ro[4] = x2;
      return 117;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1027;

  L1054:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DImode)
    goto ret0;
  if (GET_CODE (x2) == PLUS && 1)
    goto L1055;
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L1070;
    }
  goto ret0;

  L1055:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[0] = x3;
      goto L1056;
    }
  goto ret0;

  L1056:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == LABEL_REF && 1)
    goto L1057;
  goto ret0;

  L1057:
  x4 = XEXP (x3, 0);
  ro[1] = x4;
  goto L1058;

  L1058:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1059;
  goto ret0;

  L1059:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DImode))
    {
      ro[2] = x2;
      if (! WINDOWS_NT && next_active_insn (insn) != 0
   && GET_CODE (PATTERN (next_active_insn (insn))) == ADDR_DIFF_VEC
   && PREV_INSN (next_active_insn (insn)) == operands[1])
	return 207;
      }
  goto ret0;

  L1070:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L1071;
  goto ret0;

  L1071:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L1072;
  goto ret0;

  L1072:
  x3 = XEXP (x2, 0);
  ro[1] = x3;
  if (WINDOWS_NT && next_active_insn (insn) != 0
   && GET_CODE (PATTERN (next_active_insn (insn))) == ADDR_DIFF_VEC
   && PREV_INSN (next_active_insn (insn)) == operands[1])
    return 208;
  goto ret0;

  L1028:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CALL && 1)
    goto L1029;
  goto ret0;

  L1029:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MEM && 1)
    goto L1030;
  goto ret0;

  L1030:
  x4 = XEXP (x3, 0);
  if (call_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L1031;
    }
  goto ret0;

  L1031:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L1032;

  L1032:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1033;
  goto ret0;

  L1033:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    if (WINDOWS_NT)
      return 197;
  goto ret0;

  L999:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MEM && 1)
    goto L1000;
  goto ret0;

  L1000:
  x3 = XEXP (x2, 0);
  if (call_operand (x3, DImode))
    {
      ro[0] = x3;
      goto L1001;
    }
  goto ret0;

  L1001:
  x2 = XEXP (x1, 1);
  ro[1] = x2;
  goto L1002;

  L1002:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1003;
  goto ret0;

  L1003:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    if (WINDOWS_NT)
      return 195;
  goto ret0;

  L994:
  x1 = XEXP (x0, 0);
  if (GET_MODE (x1) == DImode && GET_CODE (x1) == MEM && 1)
    goto L995;
  goto ret0;

  L995:
  x2 = XEXP (x1, 0);
  if (call_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L996;
    }
  goto ret0;

  L996:
  x1 = XEXP (x0, 1);
  if (pnum_clobbers != 0 && 1)
    {
      ro[1] = x1;
      if (! WINDOWS_NT)
	{
	  *pnum_clobbers = 2;
	  return 194;
	}
      }
  L1007:
  if (pnum_clobbers != 0 && 1)
    {
      ro[1] = x1;
      if (WINDOWS_NT)
	{
	  *pnum_clobbers = 1;
	  return 195;
	}
      }
  goto ret0;

  L1041:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 0 && 1)
    return 199;
  goto ret0;

  L1074:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 0 && 1)
    return 209;
  goto ret0;
 ret0: return -1;
}

rtx
split_1 (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  rtx tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  switch (GET_MODE (x2))
    {
    case DImode:
      switch (GET_CODE (x2))
	{
	case SIGN_EXTEND:
	  goto L24;
	case ASHIFT:
	  goto L406;
	case IF_THEN_ELSE:
	  goto L697;
	case ABS:
	  goto L724;
	case NEG:
	  goto L735;
	case SMAX:
	  goto L748;
	case SMIN:
	  goto L761;
	case UMAX:
	  goto L774;
	case UMIN:
	  goto L782;
	}
    }
  if (comparison_operator (x2, VOIDmode))
    {
      ro[1] = x2;
      goto L980;
    }
  goto ret0;

  L24:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L70;
  goto ret0;

  L70:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != SImode)
    goto ret0;
  if (GET_CODE (x4) == MULT && 1)
    goto L71;
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L26;
    }
  if (comparison_operator (x4, SImode))
    {
      ro[1] = x4;
      goto L35;
    }
  goto ret0;

  L71:
  x5 = XEXP (x4, 0);
  if (comparison_operator (x5, SImode))
    {
      ro[1] = x5;
      goto L72;
    }
  goto ret0;

  L72:
  x6 = XEXP (x5, 0);
  ro[2] = x6;
  goto L73;

  L73:
  x6 = XEXP (x5, 1);
  ro[3] = x6;
  goto L74;

  L74:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && const48_operand (x5, SImode))
    {
      ro[4] = x5;
      goto L75;
    }
  goto ret0;

  L75:
  x4 = XEXP (x3, 1);
  if (add_operand (x4, SImode))
    {
      ro[5] = x4;
      goto L76;
    }
  goto ret0;

  L76:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L77;
  goto ret0;

  L77:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      return gen_split_11 (operands);
    }
  goto ret0;

  L26:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[2] = x4;
      goto L27;
    }
  goto ret0;

  L27:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L28;
  goto ret0;

  L28:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      if (! sext_add_operand (operands[2], SImode) && INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) % 4 == 0)
	return gen_split_5 (operands);
      }
  goto ret0;

  L35:
  x5 = XEXP (x4, 0);
  ro[2] = x5;
  goto L36;

  L36:
  x5 = XEXP (x4, 1);
  ro[3] = x5;
  goto L37;

  L37:
  x4 = XEXP (x3, 1);
  if (add_operand (x4, SImode))
    {
      ro[4] = x4;
      goto L38;
    }
  goto ret0;

  L38:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L39;
  goto ret0;

  L39:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[5] = x2;
      return gen_split_6 (operands);
    }
  goto ret0;

  L406:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L407;
  goto ret0;

  L407:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L408;
    }
  goto ret0;

  L408:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && mode_width_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L409;
    }
  goto ret0;

  L409:
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ASHIFT && 1)
    goto L410;
  goto ret0;

  L410:
  x5 = XEXP (x4, 0);
  ro[3] = x5;
  goto L411;

  L411:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 3 && 1)
    goto L412;
  goto ret0;

  L412:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[4] = x3;
      goto L413;
    }
  goto ret0;

  L413:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L414;
  goto ret0;

  L414:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[5] = x2;
      if (INTVAL (operands[4]) == 64 - INTVAL (operands[2]))
	return gen_split_73 (operands);
      }
  goto ret0;

  L697:
  x3 = XEXP (x2, 0);
  if (signed_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L698;
    }
  L710:
  if (comparison_operator (x3, VOIDmode))
    {
      ro[1] = x3;
      goto L711;
    }
  goto ret0;

  L698:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L699;
    }
  goto L710;

  L699:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L700;
  goto L710;

  L700:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == PLUS && 1)
    goto L701;
  x3 = XEXP (x2, 0);
  goto L710;

  L701:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L702;
  x3 = XEXP (x2, 0);
  goto L710;

  L702:
  x4 = XEXP (x3, 1);
  if (reg_or_8bit_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L703;
    }
  x3 = XEXP (x2, 0);
  goto L710;

  L703:
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L704;
  x3 = XEXP (x2, 0);
  goto L710;

  L704:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L705;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L710;

  L705:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      return gen_split_118 (operands);
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L710;

  L711:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ZERO_EXTRACT && 1)
    goto L712;
  if (reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L936;
    }
  L946:
  if (reg_or_0_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L947;
    }
  goto ret0;

  L712:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L713;
    }
  goto ret0;

  L713:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 1 && 1)
    goto L714;
  goto ret0;

  L714:
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) == CONST_INT && 1)
    {
      ro[3] = x5;
      goto L715;
    }
  goto ret0;

  L715:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L716;
  goto ret0;

  L716:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L717;
    }
  goto ret0;

  L717:
  x3 = XEXP (x2, 2);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L718;
    }
  goto ret0;

  L718:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L719;
  goto ret0;

  L719:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (INTVAL (operands[3]) != 0)
	return gen_split_119 (operands);
      }
  goto ret0;

  L936:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L937;
    }
  x4 = XEXP (x3, 0);
  goto L946;

  L937:
  x3 = XEXP (x2, 1);
  if (reg_or_cint_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L938;
    }
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L946;

  L938:
  x3 = XEXP (x2, 2);
  if (reg_or_cint_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L939;
    }
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L946;

  L939:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L940;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L946;

  L940:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (operands[3] != const0_rtx)
	return gen_split_183 (operands);
      }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L946;

  L947:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L948;
    }
  goto ret0;

  L948:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L949;
    }
  goto ret0;

  L949:
  x3 = XEXP (x2, 2);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L950;
    }
  goto ret0;

  L950:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L951;
  goto ret0;

  L951:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (operands[3] != const0_rtx
   && (GET_CODE (operands[1]) == EQ || GET_CODE (operands[1]) == NE))
	return gen_split_184 (operands);
      }
  goto ret0;

  L724:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L725;
  goto ret0;

  L725:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L726;
  goto ret0;

  L726:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return gen_split_123 (operands);
    }
  goto ret0;

  L735:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ABS && 1)
    goto L736;
  goto ret0;

  L736:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L737;
  goto ret0;

  L737:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L738;
  goto ret0;

  L738:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return gen_split_125 (operands);
    }
  goto ret0;

  L748:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L749;
    }
  goto ret0;

  L749:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L750;
    }
  goto ret0;

  L750:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L751;
  goto ret0;

  L751:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_128 (operands);
      }
  goto ret0;

  L761:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L762;
    }
  goto ret0;

  L762:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L763;
    }
  goto ret0;

  L763:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L764;
  goto ret0;

  L764:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_131 (operands);
      }
  goto ret0;

  L774:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L775;
    }
  goto ret0;

  L775:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L776;
    }
  goto ret0;

  L776:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L777;
  goto ret0;

  L777:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_134 (operands);
      }
  goto ret0;

  L782:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L783;
    }
  goto ret0;

  L783:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L784;
    }
  goto ret0;

  L784:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L785;
  goto ret0;

  L785:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_136 (operands);
      }
  goto ret0;

  L980:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L981;
    }
  goto ret0;

  L981:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      goto L982;
    }
  goto ret0;

  L982:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L983;
  goto ret0;

  L983:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (exact_log2 (INTVAL (operands[3]) + 1) >= 0
   && (GET_CODE (operands[1]) == GTU
       || GET_CODE (operands[1]) == LEU
       || ((GET_CODE (operands[1]) == GT || GET_CODE (operands[1]) == LE)
	   && extended_count (operands[2], DImode, 1) > 0)))
	return gen_split_187 (operands);
      }
  goto ret0;
 ret0: return 0;
}

rtx
split_insns (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  rtx tem;

  L9:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L10;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L21;
    }
  goto ret0;

  L10:
  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L11;
	}
      break;
    case DImode:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L47;
	}
    }
  goto ret0;

  L11:
  x1 = XEXP (x0, 1);
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) == SImode && 1)
	goto L111;
      break;
    case CONST_INT:
      ro[1] = x1;
      if (! add_operand (operands[1], SImode))
	return gen_split_219 (operands);
    }
  goto ret0;

  L111:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  if (GET_CODE (x2) == PLUS && 1)
    goto L112;
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L13;
    }
  goto ret0;

  L112:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L113;
  goto ret0;

  L113:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L114;
    }
  goto ret0;

  L114:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L115;
    }
  goto ret0;

  L115:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L116;
    }
  goto ret0;

  L116:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, SImode))
    {
      ro[4] = x2;
      if (reload_completed)
	return gen_split_16 (operands);
      }
  goto ret0;

  L13:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (! add_operand (operands[2], SImode))
	return gen_split_3 (operands);
      }
  goto ret0;

  L47:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case DImode:
      switch (GET_CODE (x1))
	{
	case PLUS:
	  goto L95;
	case SIGN_EXTEND:
	  goto L130;
	case AND:
	  goto L279;
	case ABS:
	  goto L730;
	case NEG:
	  goto L742;
	}
    }
  if (GET_CODE (x1) == CONST_INT && 1)
    {
      ro[1] = x1;
      if (! add_operand (operands[1], DImode))
	return gen_split_222 (operands);
      }
  goto ret0;

  L95:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DImode)
    goto ret0;
  if (GET_CODE (x2) == PLUS && 1)
    goto L150;
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L49;
    }
  goto ret0;

  L150:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != DImode)
    goto ret0;
  if (GET_CODE (x3) == MULT && 1)
    goto L151;
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L97;
    }
  goto ret0;

  L151:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L152;
    }
  goto ret0;

  L152:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L153;
    }
  goto ret0;

  L153:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L154;
    }
  goto ret0;

  L154:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, DImode))
    {
      ro[4] = x2;
      if (reload_completed)
	return gen_split_20 (operands);
      }
  goto ret0;

  L97:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L98;
    }
  goto ret0;

  L98:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, DImode))
    {
      ro[3] = x2;
      if (reload_completed)
	return gen_split_14 (operands);
      }
  goto ret0;

  L49:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (! add_operand (operands[2], DImode)
   && REGNO (operands[0]) != STACK_POINTER_REGNUM)
	return gen_split_8 (operands);
      }
  goto ret0;

  L130:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L131;
  goto ret0;

  L131:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L132;
  goto ret0;

  L132:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L133;
  goto ret0;

  L133:
  x5 = XEXP (x4, 0);
  if (reg_or_0_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L134;
    }
  goto ret0;

  L134:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && const48_operand (x5, SImode))
    {
      ro[2] = x5;
      goto L135;
    }
  goto ret0;

  L135:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L136;
    }
  goto ret0;

  L136:
  x3 = XEXP (x2, 1);
  if (add_operand (x3, SImode))
    {
      ro[4] = x3;
      if (reload_completed)
	return gen_split_18 (operands);
      }
  goto ret0;

  L279:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L280;
    }
  goto ret0;

  L280:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (HOST_BITS_PER_WIDE_INT == 64 && ! and_operand (operands[2], DImode))
	return gen_split_47 (operands);
      }
  goto ret0;

  L730:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (! rtx_equal_p (operands[0], operands[1]))
	return gen_split_124 (operands);
      }
  goto ret0;

  L742:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == ABS && 1)
    goto L743;
  goto ret0;

  L743:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      if (! rtx_equal_p (operands[0], operands[1]))
	return gen_split_126 (operands);
      }
  goto ret0;

  L21:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L22;
  goto ret0;

  L22:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L23;
    }
  if (GET_CODE (x2) == PC && 1)
    goto L822;
  goto ret0;
 L23:
  return split_1 (x0, insn);

  L822:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L823;
  goto ret0;

  L823:
  x3 = XEXP (x2, 0);
  if (comparison_operator (x3, VOIDmode))
    {
      ro[1] = x3;
      goto L824;
    }
  goto ret0;

  L824:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ZERO_EXTRACT && 1)
    goto L825;
  if (reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L958;
    }
  L969:
  if (reg_or_0_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L970;
    }
  goto ret0;

  L825:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L826;
    }
  goto ret0;

  L826:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 1 && 1)
    goto L827;
  goto ret0;

  L827:
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) == CONST_INT && 1)
    {
      ro[3] = x5;
      goto L828;
    }
  goto ret0;

  L828:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L829;
  goto ret0;

  L829:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L830;
  goto ret0;

  L830:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L831;

  L831:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L832;
  goto ret0;

  L832:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L833;
  goto ret0;

  L833:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (INTVAL (operands[3]) != 0)
	return gen_split_140 (operands);
      }
  goto ret0;

  L958:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L959;
    }
  x4 = XEXP (x3, 0);
  goto L969;

  L959:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L960;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L969;

  L960:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L961;

  L961:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L962;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L969;

  L962:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L963;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L969;

  L963:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (operands[3] != const0_rtx)
	return gen_split_185 (operands);
      }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L969;

  L970:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[3] = x4;
      goto L971;
    }
  goto ret0;

  L971:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L972;
  goto ret0;

  L972:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L973;

  L973:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L974;
  goto ret0;

  L974:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L975;
  goto ret0;

  L975:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (operands[3] != const0_rtx
   && (GET_CODE (operands[1]) == EQ || GET_CODE (operands[1]) == NE))
	return gen_split_186 (operands);
      }
  goto ret0;
 ret0: return 0;
}

